/*********************
 *
 *  sc_windo.c - screen windowing functions.
 *
 *  Purpose: This file contains functions that work with screen windows.
 *
 *  Blackstar C Function Library
 *  (c) Copyright 1985,1989 Sterling Castle Software
 *
 *******/

#include "blackstr.h"
#include "sc_head.h"


/********
 *
 *   sc_home() - set cursor to home position
 *
 **/

void sc_home(void)
{
    sc_setcur(colst_,rowst_);
}

/********
 *
 *   sc_winfull() - set to physical screen
 *
 **/

void sc_winfull(void)
{
    sc_windo(scolst_,srowst_,scolen_,srowen_);
}


/********
 *
 *   sc_winpush() - save window
 *
 **/

void sc_winpush(void)
{
    ut_push(colst_);
    ut_push(colen_);
    ut_push(rowst_);
    ut_push(rowen_);
}


/********
 *
 *   sc_winpop() - restore window
 *
 **/

void sc_winpop(void)
{
    rowen_=ut_pop();
    rowst_=ut_pop();
    colen_=ut_pop();
    colst_=ut_pop();
}
